/*!
 * KoliBri - The accessible HTML-Standard
 */
import{r as registerInstance,h,H as Host,g as getElement}from"./index-a051748e.js";import{v as validateLabel}from"./label-cd38babf.js";import{v as validateOpen}from"./open-0667e658.js";import{t as tryToDispatchKoliBriEvent}from"./events-fa760b68.js";import{s as setState}from"./prop.validators-8eaea103.js";import{a as propagateFocus}from"./reuse-d79ab469.js";import{h as KolIconTag,k as KolIndentedTextTag}from"./component-names-fed305c7.js";import"./a11y.tipps-4958c1a5.js";import"./dev.utils-c85f7f52.js";import"./index-117bd1aa.js";class DetailsAnimationController{constructor(e,t,i){this.detailsElement=e,this.summaryElement=t,this.contentElement=i,this.isClosing=!1,this.isExpanding=!1,this.summaryElement.addEventListener("click",this.handleSummaryClick.bind(this))}handleSummaryClick(e){e.preventDefault(),this.isClosing||!this.detailsElement.open?this.open():(this.isExpanding||this.detailsElement.open)&&this.collapse()}open(){this.detailsElement.open=!0,window.requestAnimationFrame(this.expand.bind(this))}expand(){this.isExpanding=!0,this.animateContentHeight("expand")}collapse(){this.isClosing=!0,this.animateContentHeight("collapse")}animateContentHeight(e){let t="expand"===e?0:this.contentElement.offsetHeight,i="expand"===e?this.contentElement.offsetHeight:0;this.animation&&(t=this.contentElement.offsetHeight,this.animation.cancel(),"expand"===e&&(i=this.contentElement.offsetHeight)),this.animation=this.contentElement.animate({height:[`${t}px`,`${i}px`]},{duration:matchMedia("(prefers-reduced-motion)").matches?0:250,easing:"ease-out"}),this.animation.addEventListener("finish",(()=>{this.onAnimationFinish()}),{once:!0}),this.animation.addEventListener("cancel",(()=>{"expand"===e?this.isExpanding=!1:this.isClosing=!1}),{once:!0})}onAnimationFinish(){this.detailsElement.open=this.isExpanding,this.animation=void 0,this.isClosing=!1,this.isExpanding=!1}}const defaultStyleCss=":host{--a11y-min-size:44px;background-color:white;color:black;font-family:Verdana}*{hyphens:auto;letter-spacing:inherit;word-break:break-word;word-spacing:inherit}[role=button],button:not([role=link]),.kol-input .input{min-height:var(--a11y-min-size);min-width:var(--a11y-min-size)}a,button,h1,h2,h3,h4,h5,h6,input,option,select,textarea{font-family:inherit;font-size:inherit}.visually-hidden{clip:rect(0 0 0 0);clip-path:inset(50%);height:1px;overflow:hidden;position:absolute;white-space:nowrap;width:1px}:is(a,button){background-color:transparent;border:none;margin:0;padding:0;width:100%;}[hidden]{display:none !important}:host{max-width:100%}*{box-sizing:border-box}.kol-span-wc{display:grid;place-items:center}.kol-span-wc>span{display:flex;place-items:center}a,button{cursor:pointer}.icon-only>.kol-span-wc>span>span{display:none}.hidden{display:none;visibility:hidden}:host{display:block}details{display:grid}details>summary{cursor:pointer;display:flex;place-items:center}details>summary>span{border-bottom-color:grey;border-bottom-style:solid}details>summary:focus>span,details>summary:hover>span,details[open]>summary>span{border-bottom-color:#000}.content{overflow:hidden}details>.kol-indented-text{margin:0.25em 0 0 0.5em}",KolDetailsDefaultStyle0=defaultStyleCss,KolDetails=class{constructor(e){registerInstance(this,e),this.catchRef=e=>{this.summaryElement=e,propagateFocus(this.host,this.summaryElement)},this.handleToggle=e=>{clearTimeout(this.toggleTimeout),this.toggleTimeout=setTimeout((()=>{var t,i,n,a;Boolean(null===(t=this.detailsElement)||void 0===t?void 0:t.open)!==this.state._open&&(this._open=Boolean(null===(i=this.detailsElement)||void 0===i?void 0:i.open),tryToDispatchKoliBriEvent("toggle",this.host,this._open),"function"==typeof(null===(n=this.state._on)||void 0===n?void 0:n.onToggle)&&(null===(a=this.state._on)||void 0===a||a.onToggle(e,this._open)))}),25)},this._label=void 0,this._on=void 0,this._open=!1,this._summary=void 0,this.state={_label:"…",_on:{}}}render(){return h(Host,{key:"7e913ad8f8e1e277ab20ba4e4404cf927e51bf1e",class:"kol-details"},h("details",{key:"395cb2b8246bf5b97d96d538bbadb356b2712fa8",ref:e=>{this.detailsElement=e},onToggle:this.handleToggle},h("summary",{key:"8d68e6a9661b189f4d51a84fedafacdd83b47643",ref:this.catchRef},this.state._open?h(KolIconTag,{_label:"",_icons:"codicon codicon-chevron-down"}):h(KolIconTag,{_label:"",_icons:"codicon codicon-chevron-right"}),h("span",{key:"56161ba3a9556a5736911b981c25257665ea06a4"},this.state._label)),h("div",{key:"616d04bc148caaab97ecf6dfc40eb66173d20e49","aria-hidden":!1===this.state._open?"true":void 0,class:"content",ref:e=>this.contentElement=e},h(KolIndentedTextTag,{key:"eb523a93b16331ebd3497c4ab0802007b6e3c752"},h("slot",{key:"985cea4fe6e0be5ac2d8c2d4331c8a0624c7ca0d"})))))}validateLabel(e){validateLabel(this,e,{required:!0})}validateOn(e){"object"==typeof e&&null!==e&&"function"==typeof e.onToggle&&setState(this,"_on",e)}validateOpen(e){validateOpen(this,e)}validateSummary(e){this.validateLabel(e)}componentWillLoad(){this.validateLabel(this._label||this._summary),this.validateOn(this._on),this.validateOpen(this._open)}componentDidLoad(){if(this.detailsElement&&this.summaryElement&&this.contentElement){const e=new DetailsAnimationController(this.detailsElement,this.summaryElement,this.contentElement);this.state._open&&e.open()}}get host(){return getElement(this)}static get watchers(){return{_label:["validateLabel"],_on:["validateOn"],_open:["validateOpen"],_summary:["validateSummary"]}}};KolDetails.style={default:KolDetailsDefaultStyle0};export{KolDetails as kol_details};